(* 
  $Id: nds.inc 25 2007-12-10 21:06:46Z p4p3r0 $
  ------------------------------------------------------------------------------
  	Copyright (C) 2005
  		Jason Rogers (dovoto)
  		Dave Murphy (WinterMute)
  	
  	This software is provided 'as-is', without any express or implied
  	warranty.  In no event will the authors be held liable for any
  	damages arising from the use of this software.
  	
  	Permission is granted to anyone to use this software for any
  	purpose, including commercial applications, and to alter it and
  	redistribute it freely, subject to the following restrictions:
  	
  	1.	The origin of this software must not be misrepresented; you
  		must not claim that you wrote the original software. If you use
  		this software in a product, an acknowledgment in the product
  		documentation would be appreciated but is not required.
  	
  	2.	Altered source versions must be plainly marked as such, and
  		must not be misrepresented as being the original software.
  	
  	3.	This notice may not be removed or altered from any source
  		distribution.
  ------------------------------------------------------------------------------
    
    
  Conversion by Legolas (http://itaprogaming.free.fr) for freepascal compiler
  (http://www.freepascal.org)
   
  Copyright (C) 2006  Francesco Lombardi
  Check http://sourceforge.net/projects/libndsfpc for updates
   
  ------------------------------------------------------------------------------

  $Log$

*)
{$ifndef NDS_INC}
{$define NDS_INC}

{$J+}
{$INLINE ON}
{$MACRO ON}
{$PACKRECORDS C}

{$if not defined(ARM7) and not defined (ARM9)}
  {$error Either ARM7 or ARM9 must be defined}
{$endif}

{$include helper.inc}

{$include nds/jtypes.inc}
{$include nds/bios.inc}
{$include nds/card.inc}
{$include nds/dma.inc}
{$include nds/interrupts.inc}
{$include nds/ipc.inc}
{$include nds/memory.inc}
{$include nds/system.inc}
{$include nds/timers.inc}

{$ifdef ARM9}
  {$include nds/arm9/background.inc}
  {$include nds/arm9/boxtest.inc}
  {$include nds/arm9/cache.inc}
  {$include nds/arm9/console.inc}
  {$include nds/arm9/exceptions.inc}
  {$include nds/arm9/image.inc}
  {$include nds/arm9/input.inc}
  {$include nds/arm9/math.inc}
  {$include nds/arm9/pcx.inc}
  {$include nds/arm9/rumble.inc}
  {$include nds/arm9/sound.inc}
  {$include nds/arm9/trig_lut.inc}
  {$include nds/arm9/video.inc}
  {$include nds/arm9/videoGL.inc}
  {$include nds/arm9/sprite.inc}
{$endif ARM9}

{$ifdef ARM7}
  {$include nds/arm7/audio.inc}
  {$include nds/arm7/clock.inc}
  {$include nds/arm7/serial.inc}
  {$include nds/arm7/touch.inc}
{$endif ARM7}

{$ifdef ARM7}
  {$linklib libnds7.a}
{$endif ARM7}
{$ifdef ARM9}
  {$linklib libnds9.a}
{$endif ARM9}

{$linklib libc.a}
{$linklib libgcc.a}
{$linklib libsysbase.a}

{$endif NDS_INC}

